Hide navigation sidebar
Hide table of contents sidebar
Back to top
Toggle table of contents sidebar

# ModmailConversation

class praw.models.reddit.modmail.ModmailConversation(reddit: praw.Reddit, id: Optional[str] = None, mark_read: bool = False, _data: Optional[Dict[str, Any]] = None)

  A class for modmail conversations.

  Typical Attributes

  Note

  This table describes attributes that typically belong to objects of this class. PRAW dynamically provides the attributes that Reddit returns via the API. Since those attributes are subject to change on Reddit’s end, PRAW makes no effort to document any new/removed/changed attributes, other than to instruct you on how to discover what is available. As a result, this table of attributes may not be complete. See Determine Available Attributes of an Object for detailed information.

  If you would like to add an attribute to this table, feel free to open a pull request.

  Attribute | Description
  --- | ---
  `authors` | Provides an ordered list of `Redditor` instances. The authors of each message in the modmail conversation.
  `id` | The ID of the `ModmailConversation`.
  `is_highlighted` | Whether or not the `ModmailConversation` is highlighted.
  `is_internal` | Whether or not the `ModmailConversation` is a private mod conversation.
  `last_mod_update` | Time of the last mod message reply, represented in the ISO 8601 standard with timezone.
  `last_updated` | Time of the last message reply, represented in the ISO 8601 standard with timezone.
  `last_user_update` | Time of the last user message reply, represented in the ISO 8601 standard with timezone.
  `num_messages` | The number of messages in the `ModmailConversation`.
  `obj_ids` | Provides a list of dictionaries representing mod actions on the `ModmailConversation`. Each dict contains attributes of `"key"` and `"id"`. The key can be either `""messages"` or `"ModAction"`. `"ModAction"` represents archiving/highlighting etc.
  `owner` | Provides an instance of `Subreddit`. The subreddit that the `ModmailConversation` belongs to.
  `participant` | Provides an instance of `Redditor`. The participating user in the `ModmailConversation`.
  `subject` | The subject of the `ModmailConversation`.

  __init__(reddit: praw.Reddit, id: Optional[str] = None, mark_read: bool = False, _data: Optional[Dict[str, Any]] = None)

    Initialize a `ModmailConversation` instance.

    Parameters:

      mark_read – If `True`, conversation is marked as read (default: `False`).

  archive()

    Archive the conversation.

    For example:

        reddit.subreddit("test").modmail("2gmz").archive()

  highlight()

    Highlight the conversation.

    For example:

        reddit.subreddit("test").modmail("2gmz").highlight()

  mute(*, num_days=3)

    Mute the non-mod user associated with the conversation.

    Parameters:

      num_days – Duration of mute in days. Valid options are `3`, `7`, or `28` (default: `3`).

    For example:

        reddit.subreddit("test").modmail("2gmz").mute()

    To mute for 7 days:

        reddit.subreddit("test").modmail("2gmz").mute(num_days=7)

  classmethod parse(data: Dict[str, Any], reddit: praw.Reddit, convert_objects: bool = True)

    Return an instance of `ModmailConversation` from `data`.

    Parameters:

      - data – The structured data.

      - reddit – An instance of `Reddit`.

      - convert_objects – If `True`, convert message and mod action data into objects (default: `True`).

  read(*, other_conversations: Optional[List[ModmailConversation]] = None)

    Mark the conversation(s) as read.

    Parameters:

      other_conversations – A list of other conversations to mark (default: `None`).

    For example, to mark the conversation as read along with other recent conversations from the same user:

        subreddit = reddit.subreddit("test")
        conversation = subreddit.modmail.conversation("2gmz")
        conversation.read(other_conversations=conversation.user.recent_convos)

  reply(*, author_hidden: bool = False, body: str, internal: bool = False) → ModmailMessage

    Reply to the conversation.

    Parameters:

      - author_hidden – When `True`, author is hidden from non-moderators (default: `False`).

      - body – The Markdown formatted content for a message.

      - internal – When `True`, message is a private moderator note, hidden from non-moderators (default: `False`).

    Returns:

      A `ModmailMessage` object for the newly created message.

    For example, to reply to the non-mod user while hiding your username:

        conversation = reddit.subreddit("test").modmail("2gmz")
        conversation.reply(body="Message body", author_hidden=True)

    To create a private moderator note on the conversation:

        conversation.reply(body="Message body", internal=True)

  unarchive()

    Unarchive the conversation.

    For example:

        reddit.subreddit("test").modmail("2gmz").unarchive()

  unhighlight()

    Un-highlight the conversation.

    For example:

        reddit.subreddit("test").modmail("2gmz").unhighlight()

  unmute()

    Unmute the non-mod user associated with the conversation.

    For example:

        reddit.subreddit("test").modmail("2gmz").unmute()

  unread(*, other_conversations: Optional[List[ModmailConversation]] = None)

    Mark the conversation(s) as unread.

    Parameters:

      other_conversations – A list of other conversations to mark (default: `None`).

    For example, to mark the conversation as unread along with other recent conversations from the same user:

        subreddit = reddit.subreddit("test")
        conversation = subreddit.modmail.conversation("2gmz")
        conversation.unread(other_conversations=conversation.user.recent_convos)